//+------------------------------------------------------------------+
//|                                            Kolier_SuperTrend.mq5 |
//|                                       Copyright 2010, KoliEr Li. |
//|                                                 http://kolier.li |
//+------------------------------------------------------------------+
//----  
#property copyright "Copyright 2010, KoliEr Li."
//----    
#property link "http://kolier.li"
//----   
#property version   "1.00"
//----     
#property indicator_chart_window
//----       4 
#property indicator_buffers 4
//----  4  
#property indicator_plots   4
//+----------------------------------------------+
//|           |
//+----------------------------------------------+
//----   1   
#property indicator_type1   DRAW_LINE
//----       LightSeaGreen 
#property indicator_color1  clrLightSeaGreen
//----   1 - 
#property indicator_style1  STYLE_DASH
//----    1  1
#property indicator_width1  1
//----    
#property indicator_label1  "Upper SuperTrend"
//+----------------------------------------------+
//|        |
//+----------------------------------------------+
//----   2   
#property indicator_type2   DRAW_LINE
//----        DeepPink
#property indicator_color2  clrDeepPink
//----   2 - 
#property indicator_style2  STYLE_DASH
//----    2  1
#property indicator_width2  1
//----    
#property indicator_label2  "Lower SuperTrend"
//+----------------------------------------------+
//|           |
//+----------------------------------------------+
//----   3   
#property indicator_type3   DRAW_ARROW
//----       Lime
#property indicator_color3  clrLime
//----   3  4
#property indicator_width3  4
//----   
#property indicator_label3  "Buy SuperTrend"
//+----------------------------------------------+
//|        |
//+----------------------------------------------+
//----   4   
#property indicator_type4   DRAW_ARROW
//----       Red
#property indicator_color4  Red
//----   4  4
#property indicator_width4  4
//----   
#property indicator_label4  "Sell SuperTrend"
//+----------------------------------------------+
//|                            |
//+----------------------------------------------+
#define RESET 0 //        
#define PHASE_NONE 0
#define PHASE_BUY 1
#define PHASE_SELL -1
//+-----------------------------------------------+
//|                         |
//+-----------------------------------------------+
enum Mode
  {
   SuperTrend=0,//  SuperTrend
   NewWay,      //  NeWay
   Visual,      //   
   ExpertSignal //   
  };
//+----------------------------------------------+
//|                    |
//+----------------------------------------------+
input Mode TrendMode=NewWay; //  
input uint ATR_Period=10;
input double ATR_Multiplier=3.0;
input int Shift=0; //      
//+----------------------------------------------+
//----   ,   
//----      
double UpBuffer[];
double DnBuffer[];
double BuyBuffer[];
double SellBuffer[];
//----      
int ATR_Handle;
//----      
int min_rates_total;
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+  
int OnInit()
  {
//----    ATR
   ATR_Handle=iATR(NULL,0,ATR_Period);
   if(ATR_Handle==INVALID_HANDLE)
     {
      Print("      ATR");
      return(1);
     }
//----     
   min_rates_total=int(ATR_Period+3);
//----    UpBuffer[]   
   SetIndexBuffer(0,UpBuffer,INDICATOR_DATA);
//----    1    Shift
   PlotIndexSetInteger(0,PLOT_SHIFT,Shift);
//----       1
   PlotIndexSetInteger(0,PLOT_DRAW_BEGIN,min_rates_total);
//----    ,      
   ArraySetAsSeries(UpBuffer,true);
//----   ,      
   PlotIndexSetDouble(0,PLOT_EMPTY_VALUE,0);
//----    DnBuffer[]   
   SetIndexBuffer(1,DnBuffer,INDICATOR_DATA);
//----    2    Shift
   PlotIndexSetInteger(1,PLOT_SHIFT,Shift);
//----       2
   PlotIndexSetInteger(1,PLOT_DRAW_BEGIN,min_rates_total);
//----    ,      
   ArraySetAsSeries(DnBuffer,true);
//----   ,      
   PlotIndexSetDouble(1,PLOT_EMPTY_VALUE,0);
//----    BuyBuffer[]   
   SetIndexBuffer(2,BuyBuffer,INDICATOR_DATA);
//----    1    Shift
   PlotIndexSetInteger(2,PLOT_SHIFT,Shift);
//----       3
   PlotIndexSetInteger(2,PLOT_DRAW_BEGIN,min_rates_total);
//----    ,      
   ArraySetAsSeries(BuyBuffer,true);
//----   ,      
   PlotIndexSetDouble(2,PLOT_EMPTY_VALUE,0);
//----   
   PlotIndexSetInteger(2,PLOT_ARROW,167);
//----    SellBuffer[]   
   SetIndexBuffer(3,SellBuffer,INDICATOR_DATA);
//----    2    Shift
   PlotIndexSetInteger(3,PLOT_SHIFT,Shift);
//----       4
   PlotIndexSetInteger(3,PLOT_DRAW_BEGIN,min_rates_total);
//----    ,      
   ArraySetAsSeries(SellBuffer,true);
//----   ,      
   PlotIndexSetDouble(3,PLOT_EMPTY_VALUE,0);
//----   
   PlotIndexSetInteger(3,PLOT_ARROW,167);
//----      
   string shortname;
   StringConcatenate(shortname,"SuperTrend(",ATR_Period,", ",ATR_Multiplier,", ",Shift,")");
//---           
   IndicatorSetString(INDICATOR_SHORTNAME,shortname);
//---     
   IndicatorSetInteger(INDICATOR_DIGITS,_Digits);
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int OnCalculate(const int rates_total,    //       
                const int prev_calculated,//       
                const datetime &time[],
                const double &open[],
                const double& high[],     //       
                const double& low[],      //        
                const double &close[],
                const long &tick_volume[],
                const long &volume[],
                const int &spread[])
  {
//----       
   if(BarsCalculated(ATR_Handle)<rates_total || rates_total<min_rates_total) return(RESET);
//----    
   double ATR[],atr,band_upper,band_lower;
   int limit,to_copy,bar,phase;
   static int phase_;
//----    ,     
   ArraySetAsSeries(close,true);
   ArraySetAsSeries(high,true);
   ArraySetAsSeries(low,true);
   ArraySetAsSeries(ATR,true);
//----    limit    
   if(prev_calculated>rates_total || prev_calculated<=0) //      
     {
      limit=rates_total-min_rates_total-1;               //      
      phase_=PHASE_NONE;
     }
   else
     {
      limit=rates_total-prev_calculated;                 //      
     }
//----
   to_copy=limit+1;
//----      
   if(CopyBuffer(ATR_Handle,0,0,to_copy,ATR)<=0) return(RESET);
//----   
   phase=phase_;
//----
   for(bar=limit; bar>=0 && !IsStopped(); bar--)
     {
      double mediane=(high[bar]+low[bar])/2;
      atr=ATR[bar];
      atr*=ATR_Multiplier;
      band_upper = mediane + atr;
      band_lower = mediane - atr;
      //----
      UpBuffer[bar]=0.0;
      DnBuffer[bar]=0.0;
      BuyBuffer[bar]=0.0;
      SellBuffer[bar]=0.0;
      //----
      if(phase==PHASE_NONE)
        {
         UpBuffer[bar]=mediane;
         DnBuffer[bar]=mediane;
        }
      //----
      if(phase!=PHASE_BUY && close[bar]>DnBuffer[bar+1] && DnBuffer[bar+1])
        {
         phase=PHASE_BUY;
         UpBuffer[bar]=band_lower;
         if(TrendMode<Visual) UpBuffer[bar+1]=DnBuffer[bar+1];
         else if(TrendMode==Visual) DnBuffer[bar]=DnBuffer[bar+1];
        }
      //----
      if(phase!=PHASE_SELL && close[bar]<UpBuffer[bar+1] && UpBuffer[bar+1])
        {
         phase=PHASE_SELL;
         DnBuffer[bar]=band_upper;
         if(TrendMode<Visual) DnBuffer[bar+1]=UpBuffer[bar+1];
         else if(TrendMode==Visual) UpBuffer[bar]=UpBuffer[bar+1];
        }
      //----
      if(phase==PHASE_BUY && ((TrendMode==SuperTrend && UpBuffer[bar+2]) || TrendMode>SuperTrend))
        {
         if(band_lower>UpBuffer[bar+1] || (UpBuffer[bar] && TrendMode>NewWay)) UpBuffer[bar]=band_lower;
         else UpBuffer[bar]=UpBuffer[bar+1];
        }
      //----
      if(phase==PHASE_SELL && ((TrendMode==SuperTrend && DnBuffer[bar+2]) || TrendMode>SuperTrend))
        {
         if(band_upper<DnBuffer[bar+1] || (DnBuffer[bar] && TrendMode>NewWay)) DnBuffer[bar]=band_upper;
         else DnBuffer[bar]=DnBuffer[bar+1];
        }
      //----
      if(TrendMode!=Visual)
        {
         if(DnBuffer[bar+1] && UpBuffer[bar]) BuyBuffer[bar]=UpBuffer[bar];
         if(UpBuffer[bar+1] && DnBuffer[bar]) SellBuffer[bar]=DnBuffer[bar];
        }
      else
        {
         if(!UpBuffer[bar+1] && UpBuffer[bar]) BuyBuffer[bar]=UpBuffer[bar];
         if(!DnBuffer[bar+1] && DnBuffer[bar]) SellBuffer[bar]=DnBuffer[bar];
        }
      //----   
      if(bar==1) phase_=phase;
     }
//----     
   return(rates_total);
  }
//+------------------------------------------------------------------+
